class HistoricoAluno {
	constructor(aluno_xml) {
		this.id_curso_aluno = aluno_xml.getElementsByTagName("ID_CURSO_ALUNO")[0].innerHTML;
		this.matr_aluno = aluno_xml.getElementsByTagName("MATR_ALUNO")[0].innerHTML;
		this.id_versao_curso = aluno_xml.getElementsByTagName("ID_VERSAO_CURSO")[0].innerHTML;
		this.nome_aluno = aluno_xml.getElementsByTagName("NOME_ALUNO")[0].innerHTML;
		this.cod_curso = aluno_xml.getElementsByTagName("COD_CURSO")[0].innerHTML;
		this.nome_curso = aluno_xml.getElementsByTagName("NOME_CURSO")[0].innerHTML;
		this.num_versao = aluno_xml.getElementsByTagName("NUM_VERSAO")[0].innerHTML;
		this.id_curric_aluno = aluno_xml.getElementsByTagName("ID_CURRIC_ALUNO")[0].innerHTML;
		this.id_ativ_curric = aluno_xml.getElementsByTagName("ID_ATIV_CURRIC")[0].innerHTML;
		this.ano = aluno_xml.getElementsByTagName("ANO")[0].innerHTML;
		this.media_final = aluno_xml.getElementsByTagName("MEDIA_FINAL")[0].innerHTML;
		this.sigla = aluno_xml.getElementsByTagName("SIGLA")[0].innerHTML;
		this.periodo = aluno_xml.getElementsByTagName("PERIODO")[0].innerHTML;
		this.situacao = aluno_xml.getElementsByTagName("SITUACAO")[0].innerHTML;
		this.cod_ativ_curric = aluno_xml.getElementsByTagName("COD_ATIV_CURRIC")[0].innerHTML;
		this.nome_ativ_curric = aluno_xml.getElementsByTagName("NOME_ATIV_CURRIC")[0].innerHTML;
		this.creditos = aluno_xml.getElementsByTagName("CREDITOS")[0].innerHTML;
		this.ch_total = aluno_xml.getElementsByTagName("CH_TOTAL")[0].innerHTML;
		this.id_local_dispensa = aluno_xml.getElementsByTagName("ID_LOCAL_DISPENSA")[0].innerHTML;
		this.conceito = aluno_xml.getElementsByTagName("CONCEITO")[0].innerHTML;
		this.id_nota = aluno_xml.getElementsByTagName("ID_NOTA")[0].innerHTML;
		this.id_estrutura_cur = aluno_xml.getElementsByTagName("ID_ESTRUTURA_CUR")[0].innerHTML;
		this.descr_estrutura = aluno_xml.getElementsByTagName("DESCR_ESTRUTURA")[0].innerHTML;
		this.frequencia = aluno_xml.getElementsByTagName("FREQUENCIA")[0].innerHTML;
		this.media_credito = aluno_xml.getElementsByTagName("MEDIA_CREDITO")[0].innerHTML;
		this.situacao_curriculo = aluno_xml.getElementsByTagName("SITUACAO_CURRICULO")[0].innerHTML;
	}
}

var XML_alunos_url = "xml/alunos.xml";
var xml_doc = undefined;
var alunos_xml = undefined;
var alunos = {};
var aluno = [];

var statusDisciplinasRecente = [];
var historicoDisciplinaCompleto = [];
var disciplinasObrigatorias = ["CE003","CI055","CI056","CI057","CI058","CI059","CI061","CI062","CI064","CI065","CI067","CI068","CI162","CI163","CI164","CI165","CI166","CI209","CI210","CI211","CI212","CI215","CI218","CI220","CI221","CI237","CM005","CM045","CM046","CM201","CM202","SA214"];
var disciplinasOptativas = ["CI069","CI084","CI085","CI086","CI087","CI088","CI089","CI090","CI091","CI092","CI093","CI094","CI095","CI097","CI167","CI168","CI169","CI170","CI171","CI172","CI173","CI174","CI204","CI205","CI214","CI301","CI302","CI303","CI304","CI305","CI306","CI309","CI310","CI311","CI312","CI313","CI314","CI315","CI316","CI317","CI318","CI320","CI321","CI337","CI338","CI339","CI340","CI350","CI351","CI355","CI358","CI359","CI360","CI361","CI362","CI363","CI364","CI365","CI366","CI367","CI394","CI395","CI396","ET082","CE211","CM043","HL077","SA017","SC003","SC202","SC203"];
var disciplinasTG = ["CI070","CI071","CI072","CI073","CI074","CI075","CI076","CI077","CI078","CI079","CI080","CI081","CI082","CI083","CI098","CI099","CI250","CI251","CI252","CI253","CI254","CI255","CI256","CI257","CI258","CI259","CI260","CI261"];

$(document).ready(function() {
	$.ajax({
		url: XML_alunos_url,
		type: "POST",
		dataType: "xml",
		data: {},
		success: function(response) {
			xml_doc = response.childNodes[0];
		}
	});
});

setTimeout(function(){preparaDados()},1000);

function preparaDados() {
	var GRR = '';
	alunos_xml = xml_doc.getElementsByTagName('ALUNO');
	for (i = 0; i < alunos_xml.length; i++) {
		GRR = alunos_xml[i].getElementsByTagName("MATR_ALUNO")[0].innerHTML;
		if(!alunos[GRR]) {
			alunos[GRR] = new Array;
		} 
		alunos[GRR].push(new HistoricoAluno(alunos_xml[i]));
	}
}

function historico() {
	var GRR = document.getElementById("GRR").value;
	aluno = alunos[GRR];
	if (!aluno) {
		alert("O GRR informado não consta no sistema.");
	} else {
		estadoMaisRecente();
		pintaTabela();
	}
}

function estadoMaisRecente() {
	statusDisciplinasRecente = [];
	for (i = 0; i < aluno.length; i++) {
		disciplina = aluno[i].cod_ativ_curric;
		if (statusDisciplinasRecente[disciplina] && ((aluno[i].ano > statusDisciplinasRecente[disciplina].ano) || ((aluno[i].periodo > statusDisciplinasRecente[disciplina].periodo) && (aluno[i].ano == statusDisciplinasRecente[disciplina].ano)))) {
			statusDisciplinasRecente[disciplina] = aluno[i];
		} else if (!statusDisciplinasRecente[disciplina]) {
			statusDisciplinasRecente[disciplina] = aluno[i];
		}
	}
}

function historicoCompleto(disciplina) {
	historicoDisciplinaCompleto = [];
	for (i = 0; i < aluno.length; i++) {
		if (disciplina == aluno[i].cod_ativ_curric) {
			historicoDisciplinaCompleto.push(aluno[i]);
		}
	}
	for (i = 0; i < historicoDisciplinaCompleto.length - 1; i++) {
		var maior = i;
		for (j = i + 1; j < historicoDisciplinaCompleto.length; j++) {
			if ((historicoDisciplinaCompleto[j].ano > historicoDisciplinaCompleto[maior].ano) || ((historicoDisciplinaCompleto[j].ano == historicoDisciplinaCompleto[maior].ano && historicoDisciplinaCompleto[j].periodo > historicoDisciplinaCompleto[maior].periodo))) {
				maior = j;
			}
		}
		if (maior != i) {
			var tmp = historicoDisciplinaCompleto[maior];
			historicoDisciplinaCompleto[maior] = historicoDisciplinaCompleto[i];
			historicoDisciplinaCompleto[i] = tmp;
		}
	}
}

function pintaTabela() {
	var elem = undefined;
	var disciplinasOpt = [];
	var disciplinasTrabGrad = [];
	var disciplinasEquiv = [];
	var disciplinasAntigas = [];
	var disciplina = undefined;

	//pega as optativas
	for (i = 0; i < disciplinasOptativas.length; i++) {
		disciplina = disciplinasOptativas[i];
		if (statusDisciplinasRecente[disciplina] && disciplina == statusDisciplinasRecente[disciplina].cod_ativ_curric){
			disciplinasOpt.push(statusDisciplinasRecente[disciplina]);
		}
	}

	//pega materias de tg
	for (i = 0; i < disciplinasTG.length; i++) {
		disciplina = disciplinasTG[i];
		if (statusDisciplinasRecente[disciplina] && disciplina == statusDisciplinasRecente[disciplina].cod_ativ_curric){
			disciplinasTrabGrad.push(statusDisciplinasRecente[disciplina]);
		}
	}

	//pega as matérias que não faço ideia do que são como optativas
	var materias = Object.keys(statusDisciplinasRecente);
	for (i = 0; i < materias.length; i++) {
		disciplina = statusDisciplinasRecente[materias[i]];
		if (!(disciplinasObrigatorias.includes(materias[i]) || disciplinasOptativas.includes(materias[i]) || disciplinasTG.includes(materias[i]))) {
			if (disciplina.descr_estrutura.includes("Trabalho de Graduação I")) {
				disciplinasTrabGrad.push(disciplina);
			} else if (materias[i].startsWith("CI")) {
				disciplinasAntigas.push(disciplina);
			} else {
				disciplinasOpt.push(disciplina);
			}
		}
	}
	console.log("Antigas: ",disciplinasAntigas);


	//pinta as obrigatórias
	for (i = 0; i < disciplinasObrigatorias.length; i++) {
		disciplina = disciplinasObrigatorias[i];
		elem = document.getElementById(disciplina);
	  if (elem && statusDisciplinasRecente[disciplina]) {
			status = statusDisciplinasRecente[disciplina].situacao;
			if (status.includes("Apro")) {
				elem.style.backgroundColor = '#15d80a';
			} else if (status.includes("Repr")) {
				elem.style.backgroundColor = '#f74242';
			} else if (status.includes("Matr")) {
				elem.style.backgroundColor = '#0a6ed8';
			} else if (status.includes("Equi")) {
				elem.style.backgroundColor = '#baa30e';
			}
		} else if (elem) {
			if (elem.className == "barreira") {
				elem.style.backgroundColor = '#222222';
			} else {
				elem.style.backgroundColor = '#2a2a2a';
			}
		}
	}

	//RESETA optativas
	for (j = 1; j <= 6; j++) {
		disciplina = "OPT" + j;
		elem = document.getElementById(disciplina);
	  elem.innerHTML = "OPT";
	  elem.style.backgroundColor = '#2a2a2a';
	}

	var optIndex = 1;
	//pinta as optativas APROVADAS
	for (j = 0; j < disciplinasOpt.length && optIndex <= 6; j++) {
		disciplina = "OPT" + optIndex;
		elem = document.getElementById(disciplina);
		if (disciplinasOpt[j].situacao.includes("Apro")) {
			elem.innerHTML = disciplinasOpt[j].cod_ativ_curric;
			elem.style.backgroundColor = '#15d80a';
			optIndex++;
		}
	}

	//pinta as optativas APROVADAS por dispensa
	for (j = 0; j < disciplinasOpt.length && optIndex <= 6; j++) {
		disciplina = "OPT" + optIndex;
		elem = document.getElementById(disciplina);
		if (disciplinasOpt[j].situacao.includes("Disp")) {
			elem.innerHTML = disciplinasOpt[j].cod_ativ_curric;
			elem.style.backgroundColor = '#15d80a';
			optIndex++;
		}
	}

	//pinta as optativas EQUIVALENTES, se não tiveram o suficiente
	for (j = 0; j < disciplinasOpt.length && optIndex <= 6; j++) {
		disciplina = "OPT" + optIndex;
		elem = document.getElementById(disciplina);
		if (disciplinasOpt[j].situacao.includes("Equiv")) {
			elem.innerHTML = disciplinasOpt[j].cod_ativ_curric;
			elem.style.backgroundColor = '#baa30e';
			optIndex++;
		}
	}
	//pinta as optativas MATRICULADAS, se não tiveram o suficiente
	for (j = 0; j < disciplinasOpt.length && optIndex <= 6; j++) {
		disciplina = "OPT" + optIndex;
		elem = document.getElementById(disciplina);
		if (disciplinasOpt[j].situacao.includes("Matr")) {
			elem.innerHTML = disciplinasOpt[j].cod_ativ_curric;
			elem.style.backgroundColor = '#0a6ed8';
			optIndex++;
		}
	}
	//pinta as optativas REPROVADAS, se não tiveram o suficiente
	for (j = 0; j < disciplinasOpt.length && optIndex <= 6; j++) {
		disciplina = "OPT" + optIndex;
		elem = document.getElementById(disciplina);
		if (disciplinasOpt[j].situacao.includes("Repr")) {
			elem.innerHTML = disciplinasOpt[j].cod_ativ_curric;
			elem.style.backgroundColor = '#f74242';
			optIndex++;
		}
	}

	//pinta equivalências restantes
	elem = document.getElementById("CI166");
	if (elem.style.backgroundColor != '#15d80a') {
		if (statusDisciplinasRecente["TP052"] && statusDisciplinasRecente["TP052"].situacao.includes("Equiv")) {
			elem.style.backgroundColor = '#baa30e';
		}
	}
	elem = document.getElementById("CI067");
	if (elem.style.backgroundColor != '#15d80a') {
		if (statusDisciplinasRecente["CI066"] && statusDisciplinasRecente["CI066"].situacao.includes("Equiv")) {
			elem.style.backgroundColor = '#baa30e';
		}
	}

	//pinta TG
	elem = document.getElementById("TGI");
	elem.innerHTML = "TG I";
	elem.style.backgroundColor = '#2a2a2a';
	elem = document.getElementById("TGII");	
	elem.innerHTML = "TG II";
	elem.style.backgroundColor = '#2a2a2a';
	for (j = 0; j < disciplinasTrabGrad.length; j++) {
		disciplina = disciplinasTrabGrad[j];
		if (disciplina.nome_ativ_curric.includes("II")) {
			elem = document.getElementById("TGII");
		} else {
			elem = document.getElementById("TGI");
		}
		disciplinaAnterior = elem.innerHTML;
		if (disciplinaAnterior != "TG II" && disciplinaAnterior != "TG I") {
			if ((disciplina.ano > statusDisciplinasRecente[disciplinaAnterior].ano) || ((disciplina.periodo > statusDisciplinasRecente[disciplinaAnterior].periodo) && (disciplina.ano == statusDisciplinasRecente[disciplinaAnterior].ano))) {
				elem.innerHTML = disciplina.cod_ativ_curric;
				status = disciplina.situacao;
				if (status.includes("Apro")) {
					elem.style.backgroundColor = '#15d80a';
				} else if (status.includes("Repr")) {
					elem.style.backgroundColor = '#f74242';
				} else if (status.includes("Matr")) {
					elem.style.backgroundColor = '#0a6ed8';
				} else if (status.includes("Equi")) {
					elem.style.backgroundColor = '#baa30e';
				}
			}	
		} else {
			elem.innerHTML = disciplina.cod_ativ_curric;
			status = disciplina.situacao;
			if (status.includes("Apro")) {
				elem.style.backgroundColor = '#15d80a';
			} else if (status.includes("Repr")) {
				elem.style.backgroundColor = '#f74242';
			} else if (status.includes("Matr")) {
				elem.style.backgroundColor = '#0a6ed8';
			} else if (status.includes("Equi")) {
				elem.style.backgroundColor = '#baa30e';
			}
		}	
	}
}

window.addEventListener('mousedown', handleMouseDown, false);
window.addEventListener('mouseup', handleMouseUp, false);
document.addEventListener("contextmenu", function(e){
    e.preventDefault();
    maisInformacoes(e.target);
}, false);

var rightClick = 0;
var showMoreInfo = false;

function maisInformacoes(event) {
	var disciplina = event.innerHTML.substr(0,5);
	if (disciplina == "CI166") {
		disciplina = "TP052";
	}
	disciplina = statusDisciplinasRecente[disciplina];
	if (disciplina && !showMoreInfo) {
		var código = disciplina.cod_ativ_curric;
		var nome = disciplina.nome_ativ_curric;
		var ano = disciplina.ano;
		var semestre = disciplina.periodo;
		var nota = disciplina.media_final;
		var frequencia = disciplina.frequencia;

		var dados = '<a class="close" onclick="closeModal()">&times;</a><h3><span class="código">' + código + '</span> / <span class="nome">' + nome + '</span></h3><p><strong> Última vez cursada:</strong> <span class="ano">' + ano + '</span> - <span class="semestre">' + semestre + '</span></p><p><strong>Nota:</strong> <span class="nota">' + nota + '</span></p><p><strong>Frequência:</strong> <span class="frequencia">' + frequencia + '</span></p>';

		document.getElementById("modal-content").innerHTML = "";
		document.getElementById("modal-content").innerHTML = dados;

		openModal();

  	showMoreInfo = false;
  } else if (disciplina && showMoreInfo) {
  	historicoCompleto(disciplina.cod_ativ_curric);
  	document.getElementById("modal-content").innerHTML = '<a class="close" onclick="closeModal()">&times;</a>';
  	for (i = 0; i < historicoDisciplinaCompleto.length; i++) {
  		var código = historicoDisciplinaCompleto[i].cod_ativ_curric;
			var nome = historicoDisciplinaCompleto[i].nome_ativ_curric;
			var ano = historicoDisciplinaCompleto[i].ano;
			var semestre = historicoDisciplinaCompleto[i].periodo;
			var nota = historicoDisciplinaCompleto[i].media_final;
			var frequencia = historicoDisciplinaCompleto[i].frequencia;

			if (i == historicoDisciplinaCompleto.length - 1) {
				var dados = '<h3><span class="código">' + código + '</span> / <span class="nome">' + nome + '</span></h3><p><strong> Cursada em:</strong> <span class="ano">' + ano + '</span> - <span class="semestre">' + semestre + '</span></p><p><strong>Nota:</strong> <span class="nota">' + nota + '</span></p><p><strong>Frequência:</strong> <span class="frequencia">' + frequencia + '</span></p>';
			} else {
				var dados = '<h3><span class="código">' + código + '</span> / <span class="nome">' + nome + '</span></h3><p><strong> Cursada em:</strong> <span class="ano">' + ano + '</span> - <span class="semestre">' + semestre + '</span></p><p><strong>Nota:</strong> <span class="nota">' + nota + '</span></p><p><strong>Frequência:</strong> <span class="frequencia">' + frequencia + '</span></p><hr>';
			}
			
			document.getElementById("modal-content").innerHTML += dados;

			openModal();

	  	showMoreInfo = false;
  	}
	} else {
		closeModal();
	}
}

function openModal() {
	var modal = document.getElementById('modal');
	modal.style.display = "block";
}

function closeModal() {
	var modal = document.getElementById('modal');
	if (modal.style.display == "block") {
		modal.style.display = "none";	
	}
}

window.onclick = function(){
	var modal = document.getElementById('modal');
	if (event.target == modal) {
		modal.style.display = "none";	
	}
};

function handleMouseDown(e) {
  rightClick = (e.button == 2?1:0);
  if (rightClick) showMoreInfo = true;
}

function handleMouseUp() {
  rightClick = false;
}
