class Category < ApplicationRecord
	has_many :category_games
	has_many :games, through: :category_games, dependent: :destroy
	validates_presence_of :name
	validates_presence_of :description
	validates_uniqueness_of :name
  validates_length_of :name, :minimum => 3, :maximum => 40
  validates_length_of :description, :minimum => 3, :maximum => 1000
end