class Game < ApplicationRecord
	has_one :price, dependent: :destroy
	belongs_to :developer
	has_many :category_games
	has_many :categories, through: :category_games, dependent: :destroy
	validates_uniqueness_of :name
	validates_presence_of :name
	validates_presence_of :description
	validates_inclusion_of :is_released, :in => [true, false]
	validates_presence_of :developer_id
  validates_length_of :name, :minimum => 3, :maximum => 40
  validates_length_of :description, :minimum => 3, :maximum => 1000
end
