require 'test_helper'

class CategoryTest < ActiveSupport::TestCase
  test "everything ok" do
  	category1 = categories(:postapocalyptic)
  	assert category1.save

  	category2 = categories(:fantasy)
  	assert category2.save

  	category3 = categories(:openworld)
  	assert category3.save
  end

  test "should not save with a duplicate name" do
    category1 = categories(:postapocalyptic)

    category2 = Category.new(name: "batata", description: "batata")
    category2.name = category1.name

    assert category1.save
    assert !category2.save
  end

  test "should not save with an empty description" do
  	category = categories(:rpg)
  	assert !category.save
  end

  test "should not save with an empty name" do
  	category = categories(:isometric)
  	assert !category.save
  end
end