require 'test_helper'

class DeveloperTest < ActiveSupport::TestCase
  test "everything ok" do
  	developer1 = developers(:interplay)
  	assert developer1.save

  	developer2 = developers(:blizzard)
  	assert developer2.save

  	developer3 = developers(:square_enix)
  	assert developer3.save
  end

  test "should not save with a duplicate name" do
    developer1 = developers(:interplay)

    developer2 = Developer.new(name: "batata", country: "batata")
    developer2.name = developer1.name

    assert developer1.save
    assert !developer2.save
  end

  test "should not save with an empty country" do
  	developer = developers(:capivara_games)
  	assert !developer.save
  end

  test "should not save with an empty name" do
  	developer = developers(:taleworlds)
  	assert !developer.save
  end
end
