require 'test_helper'

class GameTest < ActiveSupport::TestCase
  test "everything ok" do
    # inicializa o dev pra pegar o developer_id
    developer = developers(:interplay)
    developer.save

    # normal
    game1 = games(:fallout_i)
    game1.developer_id = developer.id

    # normal mas is_released false
    game2 = games(:fallout_ii)
    game2.developer_id = developer.id

    assert game1.save
    assert game2.save
  end

  test "should not save with duplicate name" do
    developer = developers(:interplay)
    developer.save

    game1 = games(:fallout_i)
    game1.developer_id = developer.id

    game2 = Game.new(name: "batata", description:"batata", is_released: true, developer_id: developer.id)
    game2.developer_id = developer.id
    game2.name = game1.name

    assert game1.save
    assert !game2.save
  end 

  test "should not save with empty name" do
    developer = developers(:blizzard)
    developer.save

    game = games(:diablo)
    game.developer_id = developer.id
    assert !game.save
  end 

  test "should not save with empty description" do
    developer = developers(:gamefreak)
    developer.save

    game = games(:pokemon)
    game.developer_id = developer.id
    assert !game.save
  end

  test "should not save with empty is_released" do
    developer = developers(:square_enix)
    developer.save

    game = games(:dark_souls)
    game.developer_id = developer.id
    assert !game.save
  end

  test "should not save with empty developer_id" do
    game = games(:divine_divinity)
    assert !game.save
  end
end
