require 'test_helper'

class PriceTest < ActiveSupport::TestCase
	test "everything ok" do
    developer = developers(:interplay)
    developer.save

    game = games(:fallout_i)
    game.developer_id = developer.id
    game.save

    price = prices(:fallout1)
    price.game_id = game.id

    assert price.save
  end

	test "should not save with duplicate game_id" do
    developer = developers(:interplay)
    developer.save

    game = games(:fallout_i)
    game.developer_id = developer.id
    game.save

    price1 = prices(:fallout1)
    price1.game_id = game.id
    price1.save

    price2 = Price.new(price_us: 1, price_br: 2, price_ru: 3)
    price2.game_id = game.id

    assert !price2.save
  end

	test "should not save with empty price_ru" do
		developer = developers(:interplay)
    developer.save

    game = games(:fallout_ii)
    game.developer_id = developer.id
    game.save

    price = prices(:fallouti)
    price.game_id = game.id

    assert !price.save
  end

	test "should not save with empty price_br" do
		developer = developers(:interplay)
    developer.save

    game = games(:fallout_ii)
    game.developer_id = developer.id
    game.save

    price = prices(:fallouti)
    price.game_id = game.id

    assert !price.save
  end

	test "should not save with empty price_us" do
		developer = developers(:interplay)
    developer.save

    game = games(:fallout_ii)
    game.developer_id = developer.id
    game.save

    price = prices(:falloutiii)
    price.game_id = game.id

    assert !price.save
  end
end
